#include "micros.h"
#include "stdint.h"
#include "stm32f4xx.h"                  // Device header
#include "delay.h"
uint8_t temp, hum;
int8_t read_dht(void)
	{
	RCC->AHB1ENR|=RCC_AHB1ENR_GPIOAEN;

	uint8_t bits[5];
	uint8_t cnt = 7;
	uint8_t idx = 0;
	for (int i=0; i< 5; i++) {bits[i] = 0;}
	//set PA8 to output
	GPIOA->MODER|=GPIO_MODER_MODE8_0;
	GPIOA->ODR&=~GPIO_ODR_OD8;
	delay(18);
	GPIOA->ODR|=GPIO_ODR_OD8;
	reset_micros();
	uint32_t start=micros();
	for(int i=0;i<1000;i++);
	GPIOA->MODER&=~GPIO_MODER_MODE8_0;
	//GPIOC->PUPDR|=GPIO_PUPDR_PUPD0_0;
	unsigned int loopCnt = 1000000;

	while(!(GPIOA->IDR & GPIO_IDR_ID8)){if (loopCnt-- == 0) return -2;}
	loopCnt = 10000;
	while((GPIOA->IDR & GPIO_IDR_ID8)){if (loopCnt-- == 0) return -2;}

	for (int i=0; i<40; i++)
  {
    loopCnt = 100000;
    while(!(GPIOA->IDR & GPIO_IDR_ID8))
		{if (loopCnt-- == 0) return -2;}

    unsigned long t = micros();

    loopCnt = 1000000;
    while((GPIOA->IDR & GPIO_IDR_ID8))
      if (loopCnt-- == 0)
			{return -2;}

    if ((micros() - t) > 40) bits[idx] |= (1 << cnt);
    if (cnt == 0)
    {
      cnt = 7;
      idx++;
    }
    else cnt--;
  }

	temp= bits[2];
	hum= bits[0];
	uint8_t sum = bits[0] + bits[2];
  if (bits[4] != sum)
	{return -1;}

  return 0;

	}

uint8_t read_temp(){return temp;}
uint8_t read_hum(){return hum;}
