#include "oled.h"
#include "dht.h"
#include "micros.h"
#include "stdio.h"
#include "fonts.h"
extern void SysClockConfig(void);
uint8_t temperature,humidity;
int8_t error;

char data[20];

int main(void)
	{
		SysClockConfig();
		systick_init_ms(100000000);
		micros_init(100);
		SSD1306_Init();
		SSD1306_GotoXY (0,0);
		SSD1306_Puts ("DHT11", &Font_11x18, 1);
		SSD1306_GotoXY (0,20);
		SSD1306_Puts ("STM32", &Font_11x18, 1);
		SSD1306_UpdateScreen(); //display
		delay(3000);
		SSD1306_Clear();

		while(1)
			{
				error=read_dht();
				temperature=read_temp();
				humidity=read_hum();
				sprintf(data,"temp=%u C",temperature);
				SSD1306_GotoXY (0,0);
				SSD1306_Puts (data, &Font_11x18, 1);
				sprintf(data,"hum=%u C",humidity);
				SSD1306_GotoXY (0,20);
				SSD1306_Puts (data, &Font_11x18, 1);
				SSD1306_UpdateScreen(); //display
				delay(1000);
			}
	}

